package com.company.nested_embeddable.entity;

import io.jmix.core.entity.annotation.EmbeddedParameters;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;

import java.util.UUID;

@JmixEntity
@Table(name = "TEST_ENTITY")
@Entity
public class TestEntity {

    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @EmbeddedParameters(nullAllowed = false)
    @Embedded
    @AttributeOverrides({
            @AttributeOverride(name = "firstLevelAttribute", column = @Column(name = "EMBEDDED_ATTRIBUTE1_FIRST_LEVEL_ATTRIBUTE")),

            // This is the missing @AttributeOverride for the 2nd level attribute.
            @AttributeOverride(name = "firstLevelEmbeddedAttribute.secondLevelAttribute", column = @Column(name = "EMBEDDED_ATTRIBUTE1_FIRST_LEVEL_EMBEDDED_ATTRIBUTE_SECOND_LEVEL_ATTRIBUTE"))
    })
    private FirstLevelEmbeddable embeddedAttribute1;

    @EmbeddedParameters(nullAllowed = false)
    @Embedded
    @AttributeOverrides({
            @AttributeOverride(name = "firstLevelAttribute", column = @Column(name = "EMBEDDED_ATTRIBUTE2_FIRST_LEVEL_ATTRIBUTE")),

            // This is the missing @AttributeOverride for the 2nd level attribute.
            @AttributeOverride(name = "firstLevelEmbeddedAttribute.secondLevelAttribute", column = @Column(name = "EMBEDDED_ATTRIBUTE2_FIRST_LEVEL_EMBEDDED_ATTRIBUTE_SECOND_LEVEL_ATTRIBUTE"))
    })
    private FirstLevelEmbeddable embeddedAttribute2;

    public FirstLevelEmbeddable getEmbeddedAttribute2() {
        return embeddedAttribute2;
    }

    public void setEmbeddedAttribute2(FirstLevelEmbeddable embeddedAttribute2) {
        this.embeddedAttribute2 = embeddedAttribute2;
    }

    public FirstLevelEmbeddable getEmbeddedAttribute1() {
        return embeddedAttribute1;
    }

    public void setEmbeddedAttribute1(FirstLevelEmbeddable embeddedAttribute1) {
        this.embeddedAttribute1 = embeddedAttribute1;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}